var gwebs = null;

function getService() {
		gwebs = Components.classes["@gwebs.com/GWebSafety/GWebSafety;1"];
		if(gwebs == null) return;
		try{
				gwebs = gwebs.getService(Components.interfaces.IMailSafety);
		}catch(e){
				alert(e);
		}	
}

function setCache(t) {
	gwebs.ExecCommand('setCache', t);		
}

function openTab(url) {
		var browser=getBrowser();
    var tab=browser.addTab(url);
    browser.selectedTab = tab;   	
}

function openAbout() {
	gwebs.ExecCommand('openAbout', '');		
}

function openOnlineHelp() {
	var urlh = gwebs.ExecCommand('openHelp', '');
	openTab(urlh);
}

function openQuickstart() {
	var url = gwebs.ExecCommand('openQuickstart', '');		
	openTab(url);
}

function openRegister() {
	gwebs.ExecCommand('openRegister', '');			
}

function openOption() {
	gwebs.ExecCommand('OpenConfig', '');		
}

function clearCache() {
	gwebs.ExecCommand('ClearCache', '');	
}

function changeEncrypt() {
	var menuitem = document.getElementById('menu-enable-encrypt');
	var enable = menuitem.getAttribute('checked');
	var statusbar = document.getElementById('gwebs-status');

	if(enable == 'true') {		
		statusbar.setAttribute('status', 'disabled');
		statusbar.className = 'gwebs-status-enabled statusbarpanel-iconic-text';
		menuitem.setAttribute('checked', 'false');		
		toggleEncrypt('false');
		showtip('open');
	}	else {		
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);		
		prefs = prefs.getBranch("extensions.gwebs.");
				
		var run = prefs.getBoolPref('firstRun');
		if(run) {
			prefs.setBoolPref('firstRun', false);	
		}
		
		statusbar.setAttribute('status', 'enabled');
		statusbar.className = 'gwebs-status-disabled statusbarpanel-iconic-text';
		menuitem.setAttribute('checked', 'true');
		toggleEncrypt('true');
		showtip('ok');
	}
}

function setEncrypt(enable) {
	var statusbar = document.getElementById('gwebs-status');

	if(enable == 'true') {		
		statusbar.setAttribute('status', 'enabled');
		statusbar.className = 'gwebs-status-disabled statusbarpanel-iconic-text';				
	}	else {		
		statusbar.setAttribute('status', 'disabled');
		statusbar.className = 'gwebs-status-enabled statusbarpanel-iconic-text';				
	}
	toggleEncrypt(enable);
}

function toggleDecrypt(enable) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);		
	prefs = prefs.getBranch("extensions.gwebs.");
	prefs.setCharPref('decrypt', enable);	

	if(enable == 'true') {
		gwebs.ExecCommand('EnableDecrypt', '');			
	} else {
		gwebs.ExecCommand('DisableDecrypt', '');					
	}
}

function toggleEncrypt(enable) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);		
	prefs = prefs.getBranch("extensions.gwebs.");
	prefs.setCharPref('encrypt', enable);
	
	if(enable == 'true') {
		gwebs.ExecCommand('EnableEncrypt', '');		
	} else {
		gwebs.ExecCommand('DisableEncrypt', '');				
	}
}

function toggleSign(enable) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);		
	prefs = prefs.getBranch("extensions.gwebs.");
	prefs.setCharPref('sign', enable);
	
	if(enable == 'true') {
		gwebs.ExecCommand('EnableSign', '');						
	} else {
		gwebs.ExecCommand('DisableSign', '');			
	}	
}

function setKeyLocation(e) {
	gwebs.ExecCommand('SetKeyLocation', e.label);
}

function setKeyDefault() {
	gwebs.ExecCommand('SetKeyLocation', '');
}

function createMenuItem(label, cmdfun) {
	var menuItem = document.createElement("menuitem");
	menuItem._commandFunc = cmdfun;
	menuItem.setAttribute("label", label);
	menuItem.setAttribute('type', 'radio');
	menuItem.setAttribute("oncommand", "this._commandFunc(this)");		
	
	return menuItem;
};

function initRecent() {
	var menu = document.getElementById("menu-key-location");
	var menuPopup = menu.firstChild;
	var recentPaths = gwebs.ExecCommand('GetRecentPath', '');	
	if(recentPaths.length == 0) return;
		
	var paths = recentPaths.split('|');
	var pos = paths[0];
	if(pos == 0) {
		var dmenu = document.getElementById("menu-key-location-default");
		dmenu.setAttribute("checked", "true");		
	}
	
	for(var i=1; i<paths.length; i++) {
		if(paths[i].length == 0) continue;
		var menuItem = createMenuItem(paths[i], setKeyLocation);
		menuPopup.appendChild(menuItem);
		if(pos == i) 
			menuItem.setAttribute("checked", "true");		
	}	  
}

function selectFolder() {
	var path = gwebs.ExecCommand('SelectFolder', '');
	if(path) {
		var menu = document.getElementById("menu-key-location");
		var menuPopup = menu.firstChild;		
		var menuItem = createMenuItem(path, setKeyLocation);
		menuPopup.appendChild(menuItem);	
		menuItem.setAttribute("checked", "true");
	}
}

function initCache() {
	var t = gwebs.ExecCommand('getCache', '');
	var menu;
	if(t == '1') {
		menu = document.getElementById("menu-Cache-First");
	} else if(t == '2') {
		menu = document.getElementById("menu-Cache-Second");
	} else {
		menu = document.getElementById("menu-Cache-Third");	
	}
	menu.setAttribute("checked", "true");
}

function firstRun() {
	var url = gwebs.ExecCommand('openQuickstart', '');		
	url += '?s=1&v=0';
	openTab(url);	
}

function gwebsInit() {
	  getService();

		if(gwebs == null) {
			alert('MailCloak Failed to Load!');
			return;
		}
		
		gwebs.ExecCommand('gwebs_load_ok', '');
		gwebs.ExecCommand('language', window.navigator.language);
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);		
		prefs = prefs.getBranch("extensions.gwebs.");

		var run = prefs.getBoolPref('firstRun');
		if(run) {
			window.setTimeout(function() {firstRun();}, 1000);
			gwebs.ExecCommand('gen_key', '');
			prefs.setBoolPref('firstRun', false);
    }
				
		var sign = prefs.getCharPref("sign");
		var menuitem = document.getElementById('menu-enable-sign');
		menuitem.setAttribute('checked', sign);		
		toggleSign(sign);

		var encrypt = prefs.getCharPref("encrypt");
		menuitem = document.getElementById('menu-enable-encrypt');
		menuitem.setAttribute('checked', encrypt);
		setEncrypt(encrypt);
		
		initCache();
		initRecent();	
		window.setInterval(function() {gmail_flash_uplaod(window.content);}, 1000);
}

function check_upload(win) {
  for (var k = 0; k < win.frames.length; k++) {
     check_upload(win.frames[k]);
  }

	var doc = win.document;
	var nodes = doc.getElementsByTagName('embed');
	if(nodes) {
		for(var i=0; i<nodes.length; i++) {	
			if(nodes[i].id.indexOf('FLASH_UPLOADER_') != -1) {
				var fu = nodes[i];
				fu =fu.parentNode;
				var pa = fu.parentNode;
				pa.removeChild(fu);	
			}
		}
	}
}

function gmail_flash_uplaod(ev) {
	var doc = ev.document;	
	var loc = doc.location;
	if (loc && loc.href) {
		if (loc.href.indexOf('mail.google.com') != -1) {	
			check_upload(window.content);
		}
	}	
}

window.addEventListener('load', gwebsInit, false);
