// Copyright 2008, Cooliris Inc.

function gwebsJSHelper() {}

gwebsJSHelper.prototype = {
    openUrl: function(url) {
        var tabBrowser = this._frontTabBrowser();
        if (!tabBrowser) {
            return;
        }
        var tab = tabBrowser.addTab(url);
        tabBrowser.selectedTab = tab;
    },

    _frontTabBrowser: function() {
        var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
            .getService(Components.interfaces.nsIWindowMediator);
				var win = mediator.getMostRecentWindow("navigator:browser");
        		return win ? win.getBrowser() : null;
    },

    QueryInterface: function(iid) {
        if (!iid.equals(Components.interfaces.IgwebsJSHelper) &&
            !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    }
};

var gwebsJSHelperModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(this.classId, this.className, this.contractId,
            fileSpec, location, type);
    },
    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(this.classId))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        if (!iid.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        return this.factory;
    },
    canUnload: function(compMgr) {
        return true;
    },
    
    classId: Components.ID("90deef9a-3cdf-4389-a6aa-d8a16fb4d3d4"),
    className: "gwebsJSHelper",
    contractId: "@gwebs.com/gwebs/jshelper;1",
    factory: {
        createInstance: function(outer, iid) {
            if (outer != null)
                throw Components.results.NS_ERROR_NO_AGGREGATION;
            return (new gwebsJSHelper()).QueryInterface(iid);
        }
    }
};

function NSGetModule(compMgr, fileSpec) {
		return gwebsJSHelperModule;
}
